<Query Kind="Statements">
  <Reference Relative="EmployeeTraining.dll">D:\Mahesh\PhD\Papers\SIGCSE2011\LINQROXSIGCSE2011\LINQtoObjects\EmployeeTraining.dll</Reference>
  <Namespace>EmployeeTraining</Namespace>
</Query>

/*
  LINQ ROX! Integrating LINQ into the Database Curriculum 
  Suzanne W. Dietrich and Mahesh Chaudhari
  SIGCSE 2011
*/

// Population and Validation of in-memory objects
// Assumes use of LINQPad for Dump method

// Employees
var emp111 = new Employee { eID = "111", eLast = "Last111", eFirst = "First111", eSalary =  75111, eTitle = "Database Administrator" };
var emp222 = new Employee { eID = "222", eLast = "Last222", eFirst = "First222", eSalary =  51722, eTitle = "Software Engineer" };
var emp321 = new Employee { eID = "321", eLast = "Last321", eFirst = "First321", eSalary =  68321, eTitle = "Database Administrator" };
var emp333 = new Employee { eID = "333", eLast = "Last333", eFirst = "First333", eSalary =  60333, eTitle = "Sr Software Engineer" };
var emp345 = new Employee { eID = "345", eLast = "Last345", eFirst = "First345", eSalary =  59345, eTitle = "Sr Software Engineer" };
var emp369 = new Employee { eID = "369", eLast = "Last369", eFirst = "First369", eSalary =  36369, eTitle = "Software Engineer" };
var emp444 = new Employee { eID = "444", eLast = "Last444", eFirst = "First444", eSalary =  44444, eTitle = "Software Engineer" };
var emp456 = new Employee { eID = "456", eLast = "Last456", eFirst = "First456", eSalary =  45456, eTitle = "Software Engineer" };
var emp555 = new Employee { eID = "555", eLast = "Last555", eFirst = "First555", eSalary =  55555, eTitle = "Sr Software Engineer" };
var emp654 = new Employee { eID = "654", eLast = "Last654", eFirst = "First654", eSalary =  60654, eTitle = "Coach" };
var emp666 = new Employee { eID = "666", eLast = "Last666", eFirst = "First666", eSalary =  66666, eTitle = "Coach" };
var emp678 = new Employee { eID = "678", eLast = "Last678", eFirst = "First678", eSalary =  67678, eTitle = "Coach" };
var emp693 = new Employee { eID = "693", eLast = "Last693", eFirst = "First693", eSalary =  69693, eTitle = "Coach" };
var emp777 = new Employee { eID = "777", eLast = "Last777", eFirst = "First777", eSalary =  77777, eTitle = "Database Administrator" };
var emp789 = new Employee { eID = "789", eLast = "Last789", eFirst = "First789", eSalary =  78789, eTitle = "Database Administrator" };
var emp888 = new Employee { eID = "888", eLast = "Last888", eFirst = "First888", eSalary =  88888, eTitle = "Database Administrator" };
var emp963 = new Employee { eID = "963", eLast = "Last963", eFirst = "First963", eSalary =  98963, eTitle = "Manager" };
var emp987 = new Employee { eID = "987", eLast = "Last987", eFirst = "First987", eSalary =  99987, eTitle = "Manager" };
var emp999 = new Employee { eID = "999", eLast = "Last999", eFirst = "First999", eSalary = 100999, eTitle = "Manager" };
Employee[] employees = { emp111,emp222,emp321,emp333,emp345,emp369,emp444,emp456,emp555,
						 emp654,emp666,emp678,emp693,emp777,emp789,emp888,emp963,emp987,emp999 };
Console.WriteLine("Employees #: " + employees.Count());

//TechnologyArea
var DB = new TechnologyArea { aID = "DB", aTitle = "Database",				leader = emp321, aURL = "http://www.company.intranet/technology/db" };
var JA = new TechnologyArea { aID = "JA", aTitle = "Java",					leader = emp333, aURL = "http://www.company.intranet/technology/java" };
var SE = new TechnologyArea { aID = "SE", aTitle = "Software Engineering", 	leader = emp345, aURL = "http://www.company.intranet/technology/software" };
var WW = new TechnologyArea { aID = "WW", aTitle = "Web",					leader = emp369, aURL = "http://www.company.intranet/technology/web" };
TechnologyArea[] technologyAreas = {DB, JA, SE, WW};
Console.WriteLine("TechnologyArea #: " + technologyAreas.Count());

// Populate inverse relationships for leaders of TechnologyArea
emp321.leads = DB;
emp333.leads = JA;
emp345.leads = SE;
emp369.leads = WW;

//TrainingCourses
var DB01 = new TrainingCourse { cID = "DB01", area = DB, cHours =  8, cTitle = "Microsoft Access" };
var DB02 = new TrainingCourse { cID = "DB02", area = DB, cHours = 16, cTitle = "Query Languages" };
var DB03 = new TrainingCourse { cID = "DB03", area = DB, cHours =  8, cTitle = "Database Modeling" };
var DB04 = new TrainingCourse { cID = "DB04", area = DB, cHours =  8, cTitle = "Transactions" };
var JA01 = new TrainingCourse { cID = "JA01", area = JA, cHours =  8, cTitle = "Introduction to Java" };
var JA02 = new TrainingCourse { cID = "JA02", area = JA, cHours = 16, cTitle = "JavaBeans" };
var JA03 = new TrainingCourse { cID = "JA03", area = JA, cHours = 32, cTitle = "Enterprise JavaBeans" };
var JA04 = new TrainingCourse { cID = "JA04", area = JA, cHours =  8, cTitle = "JDBC" };
var SE01 = new TrainingCourse { cID = "SE01", area = SE, cHours = 16, cTitle = "Patterns" };
var SE02 = new TrainingCourse { cID = "SE02", area = SE, cHours = 32, cTitle = "Validation & Verification" };
var SE03 = new TrainingCourse { cID = "SE03", area = SE, cHours = 40, cTitle = "Software Components" };
var WW01 = new TrainingCourse { cID = "WW01", area = WW, cHours =  8, cTitle = "Dynamic HTML" };
var WW02 = new TrainingCourse { cID = "WW02", area = WW, cHours = 16, cTitle = "XML" };
var WW03 = new TrainingCourse { cID = "WW03", area = WW, cHours = 24, cTitle = "XSLT" };
TrainingCourse[] trainingCourses = {DB01, DB02, DB03, DB04, JA01, JA02, JA03, JA04, SE01, SE02, SE03, WW01, WW02, WW03 };
Console.WriteLine("TrainingCourse #: " + trainingCourses.Count());

// Populates TechnologyArea.courses
DB.courses = new List<TrainingCourse>() { DB01, DB02, DB03, DB04 };
JA.courses = new List<TrainingCourse>() { JA01, JA02, JA03, JA04 };
SE.courses = new List<TrainingCourse>() { SE01, SE02, SE03 };
WW.courses = new List<TrainingCourse>() { WW01, WW02, WW03 };

// Takes 
var t1 = new Takes { emp = emp321, course = JA01, tDate = new DateTime(2000,7,24) };
emp321.takesCourses.Add(t1);
JA01.empsTaken.Add(t1);

var t2 = new Takes { emp = emp333, course = JA04, tDate = new DateTime(2000,7,27) };
emp333.takesCourses.Add(t2);
JA04.empsTaken.Add(t2);

var t3 = new Takes { emp = emp333, course = SE01, tDate = new DateTime(2000,6,1) };
emp333.takesCourses.Add(t3);
SE01.empsTaken.Add(t3);

var t4 = new Takes { emp = emp345, course = SE01, tDate = new DateTime(2000,6,1) };
emp345.takesCourses.Add(t4);
SE01.empsTaken.Add(t4);

var t5 = new Takes { emp = emp345, course = SE02, tDate = new DateTime(2000,6,2) };
emp345.takesCourses.Add(t5);
SE02.empsTaken.Add(t5);

var t6 = new Takes { emp = emp345, course = WW01, tDate = new DateTime(2000,8,1) };
emp345.takesCourses.Add(t6);
WW01.empsTaken.Add(t6);

var t7 = new Takes { emp = emp369, course = JA04, tDate = new DateTime(2000,7,27) };
emp369.takesCourses.Add(t7);
JA04.empsTaken.Add(t7);

var t8 = new Takes { emp = emp369, course = WW01, tDate = new DateTime(2000,8,1) };
emp369.takesCourses.Add(t8);
WW01.empsTaken.Add(t8);

var t9 = new Takes { emp = emp369, course = WW02, tDate = new DateTime(2000,8,2) };
emp369.takesCourses.Add(t9);
WW02.empsTaken.Add(t9);

var t10 = new Takes { emp = emp369, course = WW03, tDate = new DateTime(2000,8,3) };
emp369.takesCourses.Add(t10);
WW03.empsTaken.Add(t10);

var t11 = new Takes { emp = emp444, course = DB01, tDate = new DateTime(2000,5,1) };
emp444.takesCourses.Add(t11);
DB01.empsTaken.Add(t11);

var t12 = new Takes { emp = emp444, course = DB02, tDate = new DateTime(2000,9,15) };
emp444.takesCourses.Add(t12);
DB02.empsTaken.Add(t12);

var t13 = new Takes { emp = emp456, course = JA01, tDate = new DateTime(2001,1,15) };
emp456.takesCourses.Add(t13);
JA01.empsTaken.Add(t13);

var t14 = new Takes { emp = emp456, course = WW01, tDate = new DateTime(2001,3,1) };
emp456.takesCourses.Add(t14);
WW01.empsTaken.Add(t14);

var t15 = new Takes { emp = emp555, course = DB03, tDate = new DateTime(2000,9,22) };
emp555.takesCourses.Add(t15);
DB03.empsTaken.Add(t15);

var t16 = new Takes { emp = emp666, course = JA01, tDate = new DateTime(2000,1,1) };
emp666.takesCourses.Add(t16);
JA01.empsTaken.Add(t16);

var t17 = new Takes { emp = emp678, course = JA01, tDate = new DateTime(2000,1,1) };
emp678.takesCourses.Add(t17);
JA01.empsTaken.Add(t17);

var t18 = new Takes { emp = emp678, course = JA02, tDate = new DateTime(2000,1,2) };
emp678.takesCourses.Add(t18);
JA02.empsTaken.Add(t18);

var t19 = new Takes { emp = emp693, course = JA01, tDate = new DateTime(2000,7,24) };
emp693.takesCourses.Add(t19);
JA01.empsTaken.Add(t19);

var t20 = new Takes { emp = emp693, course = JA02, tDate = new DateTime(2000,1,2) };
emp693.takesCourses.Add(t20);
JA02.empsTaken.Add(t20);

var t21 = new Takes { emp = emp693, course = JA03, tDate = new DateTime(2000,12,12) };
emp693.takesCourses.Add(t21);
JA03.empsTaken.Add(t21);

var t22 = new Takes { emp = emp693, course = JA04, tDate = new DateTime(2000,12,4) };
emp693.takesCourses.Add(t22);
JA04.empsTaken.Add(t22);

var t23 = new Takes { emp = emp777, course = DB01, tDate = new DateTime(2000,5,1) };
emp777.takesCourses.Add(t23);
DB01.empsTaken.Add(t23);

var t24 = new Takes { emp = emp777, course = DB02, tDate = new DateTime(2000,9,15) };
emp777.takesCourses.Add(t24);
DB02.empsTaken.Add(t24);

var t25 = new Takes { emp = emp777, course = DB03, tDate = new DateTime(2000,9,22) };
emp777.takesCourses.Add(t25);
DB03.empsTaken.Add(t25);

var t26 = new Takes { emp = emp777, course = DB04, tDate = new DateTime(2000,9,29) };
emp777.takesCourses.Add(t26);
DB04.empsTaken.Add(t26);

var t27 = new Takes { emp = emp789, course = WW01, tDate = new DateTime(2001,3,1) };
emp789.takesCourses.Add(t27);
WW01.empsTaken.Add(t27);

var t28 = new Takes { emp = emp888, course = DB01, tDate = new DateTime(2000,5,1) };
emp888.takesCourses.Add(t28);
DB01.empsTaken.Add(t28);

var t29 = new Takes { emp = emp888, course = JA01, tDate = new DateTime(2000,7,24) };
emp888.takesCourses.Add(t29);
JA01.empsTaken.Add(t29);

var t30 = new Takes { emp = emp888, course = SE01, tDate = new DateTime(2000,6,1) };
emp888.takesCourses.Add(t30);
SE01.empsTaken.Add(t30);

var t31 = new Takes { emp = emp888, course = WW01, tDate = new DateTime(2000,8,1) };
emp888.takesCourses.Add(t31);
WW01.empsTaken.Add(t31);

var t32 = new Takes { emp = emp987, course = JA01, tDate = new DateTime(2000,7,24) };
emp987.takesCourses.Add(t32);
JA01.empsTaken.Add(t32);

var t33 = new Takes { emp = emp999, course = DB01, tDate = new DateTime(2000,5,1) };
emp999.takesCourses.Add(t33);
DB01.empsTaken.Add(t33);

var t34 = new Takes { emp = emp999, course = SE01, tDate = new DateTime(2000,6,1) };
emp999.takesCourses.Add(t34);
SE01.empsTaken.Add(t34);

Takes[] takes = { t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,
                  t11,t12,t13,t14,t15,t16,t17,t18,t19,t20,
				  t21,t22,t23,t24,t25,t26,t27,t28,t29,t30,
				  t31,t32,t33,t34 };
Console.WriteLine("Takes #: " + takes.Count());

// Reflection

var employeeProperties =
	from p in typeof(Employee).GetProperties()
	orderby p.Name
	select p.Name;
employeeProperties.Dump("Employee Properties");

var technologyAreaProperties =
	from p in typeof(TechnologyArea).GetProperties()
	orderby p.Name
	select p.Name;
technologyAreaProperties.Dump("TechnologyArea Properties");

var trainingCourseProperties =
	from p in typeof(TrainingCourse).GetProperties()
	orderby p.Name
	select p.Name;
trainingCourseProperties.Dump("TrainingCourse Properties");

var takesProperties =
	from p in typeof(Takes).GetProperties()
	orderby p.Name
	select p.Name;
takesProperties.Dump("Takes Properties");

// Validation: excerpts in Figure 2

Func<Employee, bool>[] validEmployeeRules = 
{  
// String not null validation: repeat for each String  
   	e => !String.IsNullOrEmpty(e.eID),
   	e => !String.IsNullOrEmpty(e.eLast),
	e => !String.IsNullOrEmpty(e.eFirst),
	e => !String.IsNullOrEmpty(e.eTitle),
// not null: repeat for each reference property
// NOT APPLICABLE
// validate numeric values 
   	e => e.eSalary > 0,
//  uniqueness constraint
	e => 	(from Employee emp in employees
			 where emp.eID == e.eID
			 select emp).Count()==1,
// Verify instance of 1:1 relationship
   e => e.leads == null || e.leads.leader == e,  // lazy evaluation
// Verify instance of M:1 relationship 
   	e => 	(from Takes t in e.takesCourses
		     select t.emp).All(te => te == e),
};

var invalidEmployees =
  from Employee e in employees 
  where !validEmployeeRules.All(rule => rule(e))
  select e;
invalidEmployees.Dump("Invalid Employees");

Func<TechnologyArea, bool>[] validTechnologyAreaRules = 
{  
// String not null validation: repeat for each String  
   a => !String.IsNullOrEmpty(a.aID),
   a => !String.IsNullOrEmpty(a.aTitle),
   a => !String.IsNullOrEmpty(a.aURL),
// not null: repeat for each required reference property
   a => a.leader != null,
// validate numeric values 
// NOT APPLICABLE
// uniqueness constraint
	a => (from TechnologyArea area in technologyAreas
		  where area.aID == a.aID
		  select area).Count()==1,
// Verify instance of 1:1 relationship
   a => a.leader.leads == a,
// Verify instance of M:1 relationship 
	a => 	(from TrainingCourse c in a.courses 
		     select c.area).All(ar => ar == a)
};

var invalidTechnologyAreas =
  from TechnologyArea a in technologyAreas 
  where !validTechnologyAreaRules.All(rule => rule(a))
  select a;
invalidTechnologyAreas.Dump("Invalid TechnologyAreas");

Func<TrainingCourse, bool>[] validTrainingCourseRules = 
{  
// String not null validation: repeat for each String  
   c => !String.IsNullOrEmpty(c.cID),
   c => !String.IsNullOrEmpty(c.cTitle),
// not null: repeat for each required reference property
   c => c.area != null,
// validate numeric values 
   c => c.cHours > 0,
// uniqueness constraint
   c => (from TrainingCourse tc in trainingCourses
		 where tc.cID == c.cID
		 select tc).Count()==1,
// Verify instance of 1:1 relationship
// Not Applicable
// Verify instance of 1:M relationship 
   c => 	(from TrainingCourse tc in c.area.courses 
		     select tc).Contains(c),
// Verify instance of M:1 relationship 
   c => 	(from Takes t in c.empsTaken 
		     select t.course).All(tc => tc == c),
};

var invalidTrainingCourses =
  from TrainingCourse c in trainingCourses
  where !validTrainingCourseRules.All(rule => rule(c))
  select c;
invalidTrainingCourses.Dump("Invalid TrainingCourses");


Func<Takes, bool>[] validTakesRules = 
{  
// String not null validation: repeat for each String  
// NOT APPLICABLE
// not null: repeat for each required reference property
   t => t.course != null,
   t => t.emp != null,
// validate numeric values 
// NOT APPLICABLE
// uniqueness constraint
   t => (from Takes k in takes
		 where k.emp == t.emp && k.course == t.course
		 select k).Count()==1,
// Verify instance of 1:M relationship 
   t => 	(from Takes k in t.course.empsTaken 
		     select k).Contains(t),
// Verify instance of 1:M relationship 
   t => 	(from Takes k in t.emp.takesCourses 
		     select k).Contains(t)
};

var invalidTakes =
  from Takes t in takes
  where !validTakesRules.All(rule => rule(t))
  select t;
invalidTakes.Dump("Invalid Takes");

/* 
   LINQ queries from Section 2: LINQ Overview
*/
var empsMoreThan75K =
	from e in employees
	where e.eSalary > 75000
	orderby e.eSalary descending
	select new { salary = e.eSalary, 
				 name  = e.eLast + ", " + e.eFirst, 
				 title = e.eTitle };
empsMoreThan75K.Dump("empsMoreThan75K");

var empsMoreThan75Kextension =  employees
									.Where(e => (e.eSalary>75000))
									.OrderByDescending(e => e.eSalary)
									.Select(e => new { salary = e.eSalary, 
													   name  = ((e.eLast + ", ") + e.eFirst), 
													   title     = e.eTitle } );
empsMoreThan75Kextension.Dump("empsMoreThan75Kextension");


/* 
   Figure 4 Modified for LINQ to Objects
   - change table name to extent name
   - change attribute references to object references where needed
*/

var dbTrainingCourses =
  from c in trainingCourses
  where c.area == (from a in technologyAreas 
				   where a.aTitle == "Database"
				   select a).Single()
  select new {c.cID, c.cTitle, c.cHours};
dbTrainingCourses.Dump("dbTrainingCourses");

var empsWhoTookDatabaseCourses =
  from e in employees
  where takes.Any(t => t.emp == e && 
				  dbTrainingCourses.Any(db => db.cID == t.course.cID))
  select new {e.eID, e.eLast, e.eFirst, e.eTitle};
empsWhoTookDatabaseCourses.Dump("empsWhoTookDatabaseCourses");
  
var empsWhoDidNotTakeAnyCourses =
  from e in employees
  where !takes.Any(t => t.emp == e)
  select new {e.eID, e.eLast, e.eFirst, e.eTitle};
empsWhoDidNotTakeAnyCourses.Dump("empsWhoDidNotTakeAnyCourses");  
  
var empsWhoTookCoursesInMultipleTechnologyAreas=
  from e in employees
  join t in takes on e equals t.emp 
  join c in trainingCourses on t.course equals c
  group c.area by e into g
  where g.Distinct().Count() > 1
  select new {	eID = g.Key.eID,
  				eLast = g.Key.eLast,
				eFirst = g.Key.eFirst,
				eTitle = g.Key.eTitle };
empsWhoTookCoursesInMultipleTechnologyAreas.Dump("empsWhoTookCoursesInMultipleTechnologyAreas");
  
var employeesWithMinSalary =
   from e in employees
   where e.eSalary == employees.Min(m => m.eSalary)
   select new {e.eID, e.eLast, e.eFirst, e.eTitle};
employeesWithMinSalary.Dump("employeesWithMinSalary");
   
var empsWhoTookAllDBCourses =
  from e in employees
  where dbTrainingCourses.All(db => 
				(from t in takes 
				 where t.emp == e 
				 select t.course.cID).Contains(db.cID))
  select new {e.eID, e.eLast, e.eFirst, e.eTitle};
empsWhoTookAllDBCourses.Dump("empsWhoTookAllDBCourses");