<Query Kind="Statements" />

/*
  LINQ ROX! Integrating LINQ into the Database Curriculum 
  Suzanne W. Dietrich and Mahesh Chaudhari
  SIGCSE 2011
*/

/* Figure 4: LINQ to SQL */

var dbTrainingCourses =
  from c in trainingCourse
  where c.areaID == (from a in technologyArea 
					 where a.aTitle == "Database"
					 select a.aID).Single()
  select new {c.cID, c.cTitle, c.cHours};
dbTrainingCourses.Dump("dbTrainingCourses");

var empsWhoTookDatabaseCourses =
  from e in employee
  where takes.Any(t => t.eID == e.eID && 
					   dbTrainingCourses.Any(db => db.cID == t.cID))
  select new {e.eID, e.eLast, e.eFirst, e.eTitle};
empsWhoTookDatabaseCourses.Dump("empsWhoTookDatabaseCourses");
  
var empsWhoDidNotTakeAnyCourses =
  from e in employee
  where !takes.Any(t => t.eID == e.eID)
  select new {e.eID, e.eLast, e.eFirst, e.eTitle};
empsWhoDidNotTakeAnyCourses.Dump("empsWhoDidNotTakeAnyCourses");  
  
var empsWhoTookCoursesInMultipleTechnologyAreas=
  from e in employee
  join t in takes on e.eID equals t.eID 
  join c in trainingCourse on t.cID equals c.cID
  group c.areaID by e into g
  where g.Distinct().Count() > 1
  select g.Key;
empsWhoTookCoursesInMultipleTechnologyAreas.Dump("empsWhoTookCoursesInMultipleTechnologyAreas");
  
var employeesWithMinSalary =
   from e in employee
   where e.eSalary == employee.Min(m => m.eSalary)
   select e;
employeesWithMinSalary.Dump("employeesWithMinSalary");
   
var empsWhoTookAllDBCourses =
  from e in employee
  where dbTrainingCourses.All(db => 
				(from t in takes 
				 where t.eID == e.eID 
				 select t.cID).Contains(db.cID))
  select e;
empsWhoTookAllDBCourses.Dump("empsWhoTookAllDBCourses");