<Query Kind="Statements" />

/*
  LINQ ROX! Integrating LINQ into the Database Curriculum 
  Suzanne W. Dietrich and Mahesh Chaudhari
  SIGCSE 2011
*/

XElement empDB = XElement.Load(@"empTraining.xml");

var employees = empDB.Descendants("employee");

var minEmpSalary = 
  (from e in employees
   select (int) e.Element("eSalary")).Min();
   
var minSalaryEmployees =
  new XElement("minSalaryEmployees",
	new XAttribute("minSalary", minEmpSalary),
	  from e in employees
	  where (int) e.Element("eSalary") == minEmpSalary
	  select new XElement("employee",
			     new XElement("name", e.Element("eFirst").Value + " " 
									+ e.Element("eLast").Value),
				 new XElement("title", e.Element("eTitle").Value)));
minSalaryEmployees.Dump("minSalaryEmployees");

