/*
  LINQ ROX! Integrating LINQ into the Database Curriculum 
  Suzanne W. Dietrich and Mahesh Chaudhari
  SIGCSE 2011
  
  The Employee Training schema is taken from the book:
  Understanding Relational Database Query Languages
  - S. W. Dietrich, 2001
*/

-- @employee(eID/char,eLast/char,eFirst/char,eTitle/char,eSalary/numeric):eID
CREATE TABLE employee(
	eID	char(3)	PRIMARY KEY,
	eLast	varchar2(20)	NOT NULL,
	eFirst varchar2(20)	NOT NULL,
	eTitle varchar2(30)	NOT NULL,
	eSalary number(11,2)	NOT NULL
);

-- @technologyArea(aID/char,aTitle/char,aURL/char,aLeadID/char):aID
CREATE TABLE technologyArea (
	aID	char(2)	PRIMARY KEY,
	aTitle varchar2(20)	NOT NULL,
	aURL	 varchar2(50)	NOT NULL,
	aLeadID	char(3)	NOT NULL,
	FOREIGN KEY(aLeadID) references employee(eID)
);

--@trainingCourse(cID/char,cTitle/char,cHours/numeric,areaID/char):cID
CREATE TABLE trainingCourse (
	cID	char(4)	PRIMARY KEY,
	cTitle varchar2(30)	NOT NULL,
	cHours number(3)		NOT NULL,
	areaID char(2)	NOT NULL,
	FOREIGN KEY(areaID) references technologyArea(aID)
);

--@takes(eID/char,cID/char,tYear/numeric,tMonth/numeric,tDay/numeric):eID,cID
CREATE TABLE takes (
	eID	char(3)	NOT NULL,
	cID	char(4)	NOT NULL,
	tYear	number(4)	NOT NULL,
	tMonth number(2)	NOT NULL,
	tDay	 number(2)	NOT NULL,
	PRIMARY KEY(eID,cID),
	FOREIGN KEY(eID) references employee(eID),
	FOREIGN KEY(cID) references trainingCourse(cID)
);

